EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_INPUT_EVENT_CLICKED =
   EFL_EVENT_DESCRIPTION("clicked");
EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_INPUT_EVENT_CLICKED_ANY =
   EFL_EVENT_DESCRIPTION("clicked,any");
EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_INPUT_EVENT_PRESSED =
   EFL_EVENT_DESCRIPTION("pressed");
EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_INPUT_EVENT_UNPRESSED =
   EFL_EVENT_DESCRIPTION("unpressed");
EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_INPUT_EVENT_LONGPRESSED =
   EFL_EVENT_DESCRIPTION("longpressed");

void _efl_input_clickable_press(Eo *obj, Efl_Input_Clickable_Data *pd, unsigned int button);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_clickable_press, EFL_FUNC_CALL(button), unsigned int button);

void _efl_input_clickable_unpress(Eo *obj, Efl_Input_Clickable_Data *pd, unsigned int button);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_clickable_unpress, EFL_FUNC_CALL(button), unsigned int button);

void _efl_input_clickable_button_state_reset(Eo *obj, Efl_Input_Clickable_Data *pd, unsigned int button);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_clickable_button_state_reset, EFL_FUNC_CALL(button), unsigned int button);

void _efl_input_clickable_longpress_abort(Eo *obj, Efl_Input_Clickable_Data *pd, unsigned int button);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_clickable_longpress_abort, EFL_FUNC_CALL(button), unsigned int button);

Eina_Bool _efl_input_clickable_interaction_get(const Eo *obj, Efl_Input_Clickable_Data *pd);


static Eina_Value
__eolian_efl_input_clickable_interaction_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_input_clickable_interaction_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_clickable_interaction_get, Eina_Bool, 0);

static Eina_Bool
_efl_input_clickable_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_INPUT_CLICKABLE_EXTRA_OPS
#define EFL_INPUT_CLICKABLE_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_input_clickable_press, _efl_input_clickable_press),
      EFL_OBJECT_OP_FUNC(efl_input_clickable_unpress, _efl_input_clickable_unpress),
      EFL_OBJECT_OP_FUNC(efl_input_clickable_button_state_reset, _efl_input_clickable_button_state_reset),
      EFL_OBJECT_OP_FUNC(efl_input_clickable_longpress_abort, _efl_input_clickable_longpress_abort),
      EFL_OBJECT_OP_FUNC(efl_input_clickable_interaction_get, _efl_input_clickable_interaction_get),
      EFL_INPUT_CLICKABLE_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"interaction", NULL, __eolian_efl_input_clickable_interaction_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_input_clickable_class_desc = {
   EO_VERSION,
   "Efl.Input.Clickable",
   EFL_CLASS_TYPE_MIXIN,
   sizeof(Efl_Input_Clickable_Data),
   _efl_input_clickable_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_input_clickable_mixin_get, &_efl_input_clickable_class_desc, NULL, NULL);
